=== debian/changelog ===
google-glog (0.6.0-3) unstable; urgency=medium

  [ Adrian Bunk <bunk@debian.org> ]
  * Backport upstream fix for FTBFS with CMake 4 (closes: #1112973).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 15 Nov 2025 08:55:30 +0100

google-glog (0.6.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062115

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 22:44:14 +0000

google-glog (0.6.0-2) unstable; urgency=medium

  * Update Standards-Version to 4.6.2 .

  [ Dima Kogan <dkogan@debian.org> ]
  * Use absolute path to cmake modules (closes: #1031420).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 17 Feb 2023 20:32:05 +0100

google-glog (0.6.0-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 05 Apr 2022 17:33:24 +0200

google-glog (0.6.0~rc2-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 27 Mar 2022 14:15:01 +0200

google-glog (0.6.0~rc1-3) unstable; urgency=medium

  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 20 Mar 2022 12:50:53 +0100

google-glog (0.6.0~rc1-2) experimental; urgency=medium

  * Link tests with atomic when needed.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 06 Mar 2022 23:37:27 +0100

google-glog (0.6.0~rc1-1) experimental; urgency=medium

  * New upstream release.
  * Rename library package to libgoogle-glog0v6 due to ABI breakage.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 05 Mar 2022 10:45:05 +0100

google-glog (0.5.0+really0.4.0-2) unstable; urgency=medium

  * Configure / build / install shared libraries last (closes: #997128).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 04 Nov 2021 07:37:34 +0100
