## google-glog 0.7.0

=== debian/changelog ===
google-glog (0.7.0-1) experimental; urgency=medium

  * New upstream release.
  * Update patches.
  * Library transition from libgoogle-glog0v6t64 to libgoogle-glog2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 16 Mar 2024 18:20:41 +0100
