## google-glog 0.7.1

=== debian/changelog ===
google-glog (0.7.1-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 18 Jun 2024 20:58:47 +0200
