=== debian/control ===
Source: google-glog
Section: libs
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), cmake, libgflags-dev, libunwind-dev [i386 amd64] | libunwind7-dev [i386 amd64]
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/google/glog

Package: libgoogle-glog-dev
Section: libdevel
Architecture: any
Depends: libgoogle-glog2 (= ${binary:Version}), libgflags-dev, libunwind-dev [i386 amd64] | libunwind7-dev [i386 amd64], ${misc:Depends}
Description: library that implements application-level logging.
 This library provides logging APIs based on C++-style streams and
 various helper macros.
 .
 This package contains static and debug libraries and header files for
 developing applications.

Package: libgoogle-glog2
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library that implements application-level logging.
 This library provides logging APIs based on C++-style streams and
 various helper macros.
 .
 This package contains shared libraries.
